/**
 *  Html Class
 */

public class Html {

    /**
     * Html Constructor
     */

    private Html() {

    }

    /**
     * getHtml 	Mehtod 
     *
     * @parm 		String		s
     */

    public static String getHtml(String s) {
        return "\n<html>\n" + s + "\n</html>";
    }

    /**
     * getHead	 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getHead(String s) {
        return "<Head>\n" + s + "\n</Head>\n";
    }


    /**
     * getTitle	 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getTitle(String s) {
        return "<title>\n" + s + "\n</title>\n";
    }


    /**
     * getBody	 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getBody(String s) {
        return "<body>\n" + s + "\n</body>";
    }


    /**
     * getH1		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getH1(String s) {
        return "<h1>\n" + s + "\n</h1>";
    }

    /**
     * getH2		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */	

    public static String getH2(String s) {
        return "<h2>\n" + s + "\n</h2>";
    }


    /**
     * getH3		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */	

    public static String getH3(String s) {
        return "<h3>\n" + s + "\n</h3>";
    }



    /**
     * getH4		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getH4(String s) {
        return "<h4>\n" + s + "\n</h4>";
    }


    /**
     * getH5		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getH5(String s) {
        return "<h5>\n" + s + "\n</h5>";
    }


    /**
     * getH6		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */	

    public static String getH6(String s) {
        return "<h6>\n" + s + "\n</h6>";
    }


    /**
     * getForm	  Mehtod 
     *
     * @parm		  String		 action	
     * @parm		  String		 method
     * @parm        String         data 	
     * @return	  String		
     */

    public static String getForm(String action, String method, String s) {
        return "\n<form action=" + quote(action) +
               "method=" + quote(method) +">\n"  +
               s + ' ' 	+ " </form >\n";
    }


    /**
     * getTable	  Mehtod 
     *
     * @parm		  String		 data	
     * @parm		  String		 border
     * @parm        String         width 	
     * @parm        String         noWrap 	
     * @return	  String		
     */

    public static String getTable(String s, String border,
                                  String width, String noWrap) {

        return "\n<Table Border=" + quote(border) +
               "Width=" + quote(width) + noWrap + ">" +
               s + "</Table>";

    }

    /**
     * getTable	  Mehtod 
     *
     * @parm		  int			 no of rows	
     * @parm		  int			 no of columns
     * @return	  String		
     */

    public static String getTable(int nr, int nc) {
        String s = "\n<Table Border=1>";

        for (int r = 1; r <= nr; r++) {
            s = s + getTr(getRow(r, nc));
            // assume number of columns is the
            // same for each row
        }

        return s + "</table>";
    }

    /**
     * getSheet	 Mehtod 
     *
     * @parm		 String[][]	 data		
     * @return	 String		
     */

    public static String getSheet(String a[][]) {
        String s = "";

        for (int i=0; i < a.length; i++) {
            s = s + "<tr>";

            for (int j=0; j < a[i].length; j++) {
                s = s + getTd(a[i][j]);
            }

            s = s + "</tr>\n";
        }

        return s;
    }



    /**
     * getRow		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getRow(String s) {
        return "\n <tr>" + s + "</tr>";

    }


    /**
     * getRow		 Mehtod 
     *
     * @parm		 String		data		
     * @parm       String     align  	
     * @return	 String		
     */

    public static String getRow(String s, String align) {
        return "\n <tr align=" + quote(align) + ">" + s + "</tr>";

    }


    /**
     * getRow		 Mehtod 
     *
     * @parm		 int		no of rows		
     * @parm		 int		no of columns		
     * @return	 String		
     */

    public static String getRow(int r, int nc) {
        String s = "";

        for (int c = 1; c <= nc; c++)
            s = s + getTd(r + "," + c + " ");

        return s;

    }


    /**
     * getTr		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getTr(String s) {
        return "<tr>" + s + "</tr>\n";
    }


    /**
     * getTd		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getTd(int w, int h, String s) {
        return "\n\t<td width=\""
               + w
               + "\" height=\"" + h + "\">"
               + s +
               "</td>\n";
    }


    /**
     * getTd		 Mehtod 
     *
     * @parm		 String		data		
     * @parm		 String		colspan		
     * @return	 String		
     */

    public static String getTd( String s, String colSpan) {
        return "\n\t<td colspan=" + quote(colSpan) + ">"
               +s+
               "</td>\n";
    }


    /**
     * getTd		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */

    public static String getTd( String s) {
        return "\n\t<td>"
               + s +
               "</td>\n";
    }


    /**
     * getTd		 Mehtod 
     *
     * @parm		 String[] 		data array		
     * @return	 String		
     */

    public static String getTd( String [] s) {
        String str = "";

        for (int i=0; i < s.length; i++) {
            str = str + getTd(s[i]);
        }

        return str;
    }


    /**
     * getInput	 Mehtod 
     *
     * @parm		 String		 type		
     * @parm		 String		 name		
     * @parm		 String		 value		
     * @parm		 int		 size		
     * @return	 String		
     */

    public static String getInput(String type, String name,
                                  String value, int size) {
        return
            "\n<input type=" + quote(type)
            + "name=" + quote(name)
            + " value="+ quote(value)
            + "size=" + size
            + ">\n";
    }


    /**
     * getInput	 Mehtod 
     *
     * @parm		 String		 type		
     * @parm		 String		 name		
     * @parm		 int		 size		
     * @return	 String		
     */

    public static String getInput(String type, String name, String value) {
        return
            "\n<input type=" + quote(type)
            + "name=" + quote(name)
            + " value="+ quote(value)
            + ">";
    }


    /**
     * getTextField Mehtod 
     *
     * @parm		  String		 name		
     * @return	  String		
     */

    public static String getTextField(String name) {

        return getTextField(name, "", 30);
    }


    /**
     * getTextField Mehtod 
     *
     * @parm		  String		 name		
     * @parm		  String		 value		
     * @return	  String		
     */

    public static String getTextField(String name, String value) {

        return getTextField(name, value, 30);
    }

    /**
     * getTextField Mehtod 
     *
     * @parm		  String		 name		
     * @parm		  String		 value		
     * @parm		  int		 	 size
     * @return	  String		
     */


    public static String getTextField(String name, String value, int size) {

        return getInput("text", name, value, size);
    }


    /**
     * getPassField Mehtod 
     *
     * @parm		  String		 name		
     * @return	  String		
     */

    public static String getPassField(String name) {

        return getPassField(name, "", 30);
    }


    /**
     * getPassField Mehtod 
     *
     * @parm		  String		 name		
     * @parm		  String		 value		
     * @return	  String		
     */

    public static String getPassField(String name, String value) {

        return getPassField(name, value, 30);
    }

    /**
     * getPassField Mehtod 
     *
     * @parm		  String		 name		
     * @parm		  String		 value		
     * @parm		  int		 	 size
     * @return	  String		
     */

    public static String getPassField(String name, String value, int size) {

        return getInput("password", name, value, size);
    }


    /**
     * getHiddenField Mehtod 
     *
     * @parm		  String		 name		
     * @parm		  String		 value		
     * @return	  String		
     */

    public static String getHiddenField(String name, String value) {

        return getInput("Hidden", name, value);
    }


    /**
     * getSelect	 Mehtod 
     *
     * @parm		 String		 name		
     * @return	 String		
     */

    public static String getSelect(String name) {
        return 	"\n\t" + "<Select "
                + "name=" + quote(name)
                + ">";
    }


    /**
     * getOption	 Mehtod 
     *
     * @parm		 String		 value	
     * @return	 String		
     */

    public static String getOption(String value) {
        return "\n\t\t" + "<Option "
               + "Value=" + quote(value)
               + ">" + value;
    }


    /**
     * getRadio	 Mehtod 
     *
     * @parm		 String		 name		
     * @parm		 String		 value		
     * @return	 String		
     */

    public static String getRadio(String name, String value) {

        return 	getInput("radio",name,value) + value;
    }


    /**
     * getRadioButtons	 Mehtod 
     *
     * @parm				 String		 name		
     * @parm		 		 int	     no of buttons
     * @return	 		 String		
     */

    public static String  getRadioButtons(String name, int b) {
        String s ="";

        for (int i=1; i <= b; i++)
            s = s + getRadio(name, i+"");

        return s;
    }


    /**
     * getComboBox Mehtod 
     *
     * @parm		 String		 name		
     * @parm		 int		 value		
     * @return	 String		
     */

    public static String  getComboBox(String name, int value) {

        String s = "" + getSelect(name);

        for (int i = 1; i <= value; i++) {
            s = s + getOption(i + "") ;
        }

        return s;
    }


    /**
     * getComboBox Mehtod 
     *
     * @parm		 String		 name		
     * @parm		 String[]	 value		
     * @return	 String		
     */

    public static String  getComboBox(String name, String[] value) {

        String s = "" + getSelect(name);

        for (int i = 0; i < value.length; i++) {
            s = s + getOption(value[i] + "") ;
        }

        s = s + "\n\t</Select>";

        return s;
    }



    /**
     * getSubmitButton Mehtod 
     *
     * @return	     String		
     */

    public static String getSubmitButton() {

        return getInput("Submit", "Submit", "Submit");
    }


    /**
     * getListItem Mehtod 
     *
     * @parm		 String		data
     * @return	 String		
     */

    public static String getListItem(String s) {

        return "<li>\n" + s + "\n</li>";
    }


    /**
     * getBreak	 Mehtod 
     *
     * @return	 String		
     */

    public static String getBreak() {

        return "\n<br>\n ";
    }


    /**
     * getBold	 Mehtod 
     *
     * @return	 String		
     */

    public static String getBold(String s) {

        return "<b>" + s + "</b>";
    }

    /**
     * getUnderline Mehtod 
     *
     * @return	  String		
     */

    public static String getUnderline(String s) {

        return "<u>" + s + "</u>";
    }

    /**
      * getCenter	 Mehtod 
      *
      * @return	 String		
      */

    public static String getCenter(String s) {

        return "<center>" + s + "</center>";
    }


    /**
     * getP		 Mehtod 
     *
     * @parm		 String		data		
     * @return	 String		
     */	

    public static String getP(String s) {

        return "<p>\n" + s + "\n</p>";
    }

    /**
     * quote		  Mehtod 
     *
     * @parm		  String		 data		
     * @return	  String		
     */

    public static String quote(String s) {

        return '\"' + s + "\" ";
    }

    /**
     * getFont	  Mehtod 
     *
     * @parm		  String		 data		
     * @return	  String		
     */

    public static String getFont(String s, String size) {

        return "<font " + "size = " + size + ">"
               + s
               + "</font>";
    }
}